unit MainForm_ram;

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Grids, StdCtrls, ExtCtrls,

  modul_ram;


const
  Kopfzeile = '00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F';
  Font_Size = 14;

type
  { ***** Arbeitsspeicher ROM/Form_RAM ***** }

  { TForm_RAM }

  TForm_RAM = class(TForm)
    Image_RAM: TImage;
    ScrollBar1: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Inhalt_anzeigen; { Inhalt_anzeigen }
  private
    { private declarations }
    Mem_Red : Array [0..65535] of Byte;
  public
    { public declarations }
    procedure loesche_Mem_Red; { loesche Mem_Red }
    procedure setze_Mem_Red(Adress : Word); { setze Mem_Red an der Adresse }
    procedure setze_Mem_Green(Adress : Word); { setze Mem_Green an der Adresse }

    procedure Lade_Datei(Adress : Word; DateiName : String); { eine Datei in den Speicher schreiben }
  end;


var
  Form_RAM : TForm_RAM;

implementation

uses
  MainForm_EMUZ80, MainForm_buttons;


{ ##### Arbeitsspeicher ROM/Form_RAM ##### }



procedure TForm_RAM.FormCreate(Sender: TObject);
begin

  mod_ram := Tmod_ram.Create;
  mod_ram.RAM_loeschen;

  loesche_Mem_Red;

end; { procedure TForm_RAM.FormCreate }






procedure TForm_RAM.FormShow(Sender: TObject);
begin

  ScrollBar1.Max:=(65535 DIV 16) - 32;
  Form_RAM.Width:=Image_RAM.Picture.Bitmap.Width+ScrollBar1.Width;
  Form_RAM.Height:=Image_RAM.Picture.Bitmap.Height;

end; { procedure TForm_RAM.FormShow }



{ *** MEM-Unterprogramme *** }


procedure TForm_RAM.loesche_Mem_Red; { loesche Mem_Red }
var
  M_Zaehler : Integer;
begin
  for M_Zaehler:=0 to 65535 do
    Mem_Red[M_Zaehler]:=0;

end; { procedure TForm_RAM.loesche_Mem_Red }




procedure TForm_RAM.setze_Mem_Red(Adress : Word); { setze Mem_Red an der Adresse }
begin
  Mem_Red[Adress]:=1;

end; { procedure TForm_RAM.setze_Mem_Red }




procedure TForm_RAM.setze_Mem_Green(Adress : Word); { setze Mem_Green an der Adresse }
begin
  Mem_Red[Adress]:=2;

end; { procedure TForm_RAM.setze_Mem_Green }




procedure TForm_RAM.Lade_Datei(Adress : Word; DateiName : String); { eine Datei in den Speicher schreiben }
var
  COM_Datei : TMemoryStream;
  b1 : Byte;
  Zaehler_l1, l1 : Word;
begin
  COM_Datei := TMemoryStream.Create;

  COM_Datei.LoadFromFile(DateiName);
  TForm_BUTTONS.Memo_Protokoll.Lines.Add('Datei:'+DateiName+' eingelesen');
  l1:=COM_Datei.Size;

  COM_Datei.Position:=0;

  for Zaehler_l1:=Adress to Adress+l1 do begin
    COM_Datei.Read(b1, 1);
    mod_ram.Write_Byte(Zaehler_l1,b1);
  end; { for Zaehler_l1:=0 to l1 do }

  COM_Datei.Free;
end; { procedure TForm_RAM.Lade_Datei }







procedure TForm_RAM.ScrollBar1Change(Sender: TObject);
begin
  Inhalt_anzeigen;
end; { procedure TForm_RAM.ScrollBar1Change }




procedure TForm_RAM.Inhalt_anzeigen; { Inhalt_anzeigen }
var
  M_Zaehler, Laenge : Word;
  Z_Adresse : String;
  M_Byte : Byte;
  X_Zeiger, Y_Zeiger : Integer;
  B_Anfang, B_Ende : Integer;
begin

  Image_RAM.Picture.Bitmap.Canvas.Brush.Color:=clWhite;
  Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clBlack;
  Image_RAM.Picture.Bitmap.Canvas.Font.Name:='Courier New';
  Image_RAM.Picture.Bitmap.Canvas.Font.Size:=Font_Size;

  Image_RAM.Picture.Bitmap.Height:=(33*Image_RAM.Picture.Bitmap.Canvas.TextHeight('0'))+25;
  Image_RAM.Picture.Bitmap.Width:=Image_RAM.Picture.Bitmap.Canvas.TextWidth(Kopfzeile+' 0000  ')+30;

  Form_RAM.Width:=Image_RAM.Picture.Bitmap.Width+ScrollBar1.Width;
  Form_RAM.Height:=Image_RAM.Picture.Bitmap.Height;

  Image_RAM.Picture.Bitmap.Canvas.Rectangle(0,0,
                     Image_RAM.Picture.Bitmap.Width,Image_RAM.Picture.Bitmap.Height);

  Laenge:=0;
  Y_Zeiger:=8;
  X_Zeiger:=Image_RAM.Picture.Bitmap.Canvas.TextWidth('0');

  B_Anfang:=ScrollBar1.Position*16;
  B_Ende:=B_Anfang+(16*32)-1;

  Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clBlue;
  Image_RAM.Picture.Bitmap.Canvas.TextOut(
              X_Zeiger+Image_RAM.Picture.Bitmap.Canvas.TextWidth('0000  '),Y_Zeiger,Kopfzeile);
  Y_Zeiger:=Y_Zeiger+4+Image_RAM.Picture.Bitmap.Canvas.TextHeight('0');

  Z_Adresse:=IntToHex(B_Anfang,4);
  Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clGreen;
  Image_RAM.Picture.Bitmap.Canvas.TextOut(X_Zeiger,Y_Zeiger,Z_Adresse);
  X_Zeiger:=X_Zeiger+Image_RAM.Picture.Bitmap.Canvas.TextWidth(Z_Adresse+'00');

  for M_Zaehler:=B_Anfang to B_Ende do begin
    M_Byte:=mod_ram.Read_Byte(M_Zaehler);

{
    clBlack   clMaroon  clGreen  clOlive   clNavy  clPurple   clTeal  clGray
    clSilver  clRed     clLime   clYellow  clBlue  clFuchsia  clAqua  clWhite
}


    case Mem_Red[M_Zaehler] of
      0 : Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clBlack;
      1 : Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clRed;
      2 : Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clAqua;
    end;

    Image_RAM.Picture.Bitmap.Canvas.TextOut(X_Zeiger,Y_Zeiger,IntToHex(M_Byte,2));
    X_Zeiger:=X_Zeiger+Image_RAM.Picture.Bitmap.Canvas.TextWidth('00 ');

    Inc(Laenge);
    if Laenge=16 then begin
      Laenge:=0;
      X_Zeiger:=Image_RAM.Picture.Bitmap.Canvas.TextWidth('0');
      Image_RAM.Picture.Bitmap.Canvas.Font.Color:=clGreen;
      Image_RAM.Picture.Bitmap.Canvas.TextOut(X_Zeiger,Y_Zeiger,Z_Adresse);
      X_Zeiger:=X_Zeiger+Image_RAM.Picture.Bitmap.Canvas.TextWidth(Z_Adresse+'00');

      Y_Zeiger:=Y_Zeiger+Image_RAM.Picture.Bitmap.Canvas.TextHeight('0');
      Z_Adresse:=IntToHex(M_Zaehler+1,4);

    end; { if Laenge=8 then }
  end; { for M_Zaehler:=0 to 65535 do }

end; { procedure TForm_RAM.Inhalt_anzeigen }





procedure TForm_RAM.FormDestroy(Sender: TObject);
begin

  Form_EMUZ80.Mem_Left:=Form_RAM.Left;
  Form_EMUZ80.Mem_Top:=Form_RAM.Top;

  mod_ram.Free;

end;




initialization
  {$I mainform_ram.lrs}

end.

